<template>
	<view class="uni-page-modal-3017-2" :class="largeMode?'large-mode':''">
		<!-- 表头样式 -->
		<OIForm ref="refBaseForm" class="v-headStyle" :form="head_styledef.form" :hiddenIds="head_styledef.hiddenIds ?head_styledef.hiddenIds :[] " @on-focus="ontap"
			@on-change="onEnterChange" @on-click-prefix="classAttr_extButton" @on-click-suffix="classAttr_extButton">
		</OIForm>
		<!-- 从数据 -->
		<view class="v-panel">
			<div class="panel_title">{{param.Sub_Cls.Title}}</div>
			<!-- 从数据扫码区 -->
			<view class="v-area class_attr_body" v-if="param.Sub_Cls.Can_Add_Delete == true">
				<h4 style="margin: 15rpx 0 0 30rpx;font-weight: bold;">{{translateSys('add2')}}{{param.Sub_Cls.Name }}
				</h4>
				<view class="form-group">
					<!-- 左右布局 -->
					<p class="tx_title2">{{param.Scan_Code.Name}}:</p>
					<input type="text" class="attr_field" :value="scanCodeVal" @focus="scan_ontap" @blur="scan_onevent"
						:style="param.Scan_Code.Have_Select_Button==true?'width: '+(100-(param.Scan_Code.Name.length * 5)-14)+'%;':'width: '+(100-(param.Scan_Code.Name.length * 5)-5)+'%;'"
						:maxlength="-1">
					<div class="text-right2" v-if="param.Scan_Code.Have_Select_Button==true">
						<a @tap="scan_classAttr_extButton()"><i class="ace-icon fa"
								:class="param.Scan_Code.Img?param.Scan_Code.Img:'fa-plus-circle'"></i></a>
					</div>
					<!-- 上下布局 -->
					<!-- <text class="tx_title">{{param.Scan_Code.Name}}：</text> 
					<div class="text-right" v-if="param.Scan_Code.Have_Select_Button==true">  
						<a @tap="ms_classAttr_extButton()"><i class="ace-icon fa" :class="param.Scan_Code.Img?param.Scan_Code.Img:'fa-plus-circle'"></i></a>
					</div>
					<input type="text" value="" > -->
				</view>
			</view>

			<!-- 从数据显示详情区 -->
			<view class="v-panellist" v-for="(subpanel,iiindex) in subPanelList" @tap="onPanelClick(iiindex)"
				:class="activelist[iiindex].active==true?'bk-active':''">
				<uni-forms class="v-area dv-panel" label-align="right">
					<view v-for="(item,index) in subpanel.subClassAttr.form.items" :key="index">
						<!-- 栅格布局 -->
						<uni-row v-if="item.name == 'Layout'" :gutter="item.setting.gutter">
							<uni-col
								:span="item.setting.spanList && item.setting.spanList[key]? item.setting.spanList[key] : 24 / item.setting.col"
								v-for="(col,key) in item.setting.colList" :key="key">
								<uni-forms-item v-if="col != null"
									:label="col.labelWidth === 0 ? '' : col.label? col.label+'：':''"
									:label-width="col.labelWidth || col.labelWidth === 0 ? col.labelWidth : 100+'px'">
									<view v-if="col.disabled">{{col.value}}</view>
									<input class="uni-input" v-else-if="col.name=='Input' || col.name=='InputNumber'"
										:type="col.name=='InputNumber'?'number':'text'" v-model="col.value"
										:placeholder="col.placeholder" :maxlength="-1" />
									<view v-else>{{col.value}}</view>

								</uni-forms-item>
								<uni-forms-item v-else label=""></uni-forms-item>
							</uni-col>
						</uni-row>
						<uni-forms-item v-else :label="item.labelWidth === 0 ? '' : item.label? item.label+'：':''"
							:label-width="item.labelWidth || item.labelWidth === 0 ? item.labelWidth : 100+'px'"
							:style="{ textAlign: item.setting.align }">
							<view v-if="item.disabled">{{item.value}}</view>
							<input v-else-if="item.name=='Input' || item.name=='InputNumber' " class="uni-input"
								:type="item.name=='InputNumber'?'number':'text'" v-model="item.value"
								:disabled="item.disabled" :placeholder="item.placeholder" :maxlength="-1" />
							<view v-else>{{item.value}}</view>

						</uni-forms-item>
					</view>
				</uni-forms>
				<view class="v-paneldel" v-if="param.Sub_Cls.Can_Add_Delete == true">
					<a href="javascript:;" class="panel_del" @tap="panel_del(iiindex)"><i
							class="ace-icon fu-delete"></i></a>
				</view>
			</view>

		</view>


		<view class="view-floor">
			<button type="default" @tap="cancel" class="btn_cancel"
				v-if="param.Sub_Cls.Can_Add_Delete == true">{{translateSys('cancel')}}</button>
			<button type="default" @tap="onSave" class="btn_add" v-if="param.Sub_Cls.Can_Add_Delete == true"
				:class="saving?'btn_disabled':''" :disabled="saving">{{title}}</button>
			<button type="default" @tap="onSave" class="btn_sava" v-else-if="param.Sub_Cls.Can_Add_Delete == false"
				:class="saving?'btn_disabled':''" :disabled="saving">{{title}}</button>
		</view>
		<!-- 普通弹窗 top bottom center left right -->
		<view>
			<uni-popup class="view-popup" ref="popup" background-color="#fff" @change="popupChange">
				<view class="popup-header">{{check_list.title}}</view>
				<view class="popup-content" :class="{ 'popup-height': popupType === 'left' || popupType === 'right' }"
					:style="{'width':check_list.width?check_list.width+'px':'375rpx','height':check_list.height?check_list.height+'px':popupType =='center'?'60vh':'88vh'}">
					<view class="popup-cont"
						:style="{'height':check_list.height?check_list.height-45+'px':popupType =='center'?'50vh':'80vh'}">
						<view class="view_popup_CheckList" v-for="(item,index) in check_list.items">
							<checkbox-group class="check_list" @change="checkChange" :data-ischeck="item.check"
								:data-index="index" :style="{'margin-left': '10rpx'}">
								<label>
									<checkbox :value="item.check" :checked="item.check" />
									<text>{{item.name}}</text>
								</label>
							</checkbox-group>
						</view>
					</view>
					<view class="popup-footer">
						<button type="default" @tap="popup_sava" class="btn_popup_add">{{translateSys('ok')}}</button>
						<button type="default" @tap="popup_cancel"
							class="btn_popup_cancel">{{translateSys('cancel')}}</button>
					</view>
				</view>
			</uni-popup>
		</view>
	</view>
</template>

<script>
	import {
		Base64
	} from '@/js/Base64.js';
	import utils from "@/js/utils.js"
	import {
		appGetInfo,
		dictGetInfo
	} from "@/api/mobox.js"
	import {
		getUIStyleInfo,
		runCustomEvent,
		dataObjCreate,
		dataObjDel
	} from "@/api/data.js"
	import dayjs from "dayjs";
	import OIForm from '@/components/oi-form/index.vue'
	import buttonClickMixin from '@/mixins/button-click.js';

	export default {
		mixins: [buttonClickMixin],
		components: {
			OIForm
		},
		data() {
			return {
				largeMode: getApp().globalData.largeMode || false,
				title: this.translateSys('add2'),
				param: {},
				edit_inital_event: "", //弹窗初始化事件ID
				edit_ok_event: "", //弹窗点击OK 触发事件ID
				edit_select_compose_event: "", //选择组成对象时调用
				edit_compose_cls_id: "",
				global_attr: [],
				refdatastore: [], //引用数据存储区// {attr:'G_PRJ_' + bindattr + '_ID', value:info.id}
				scanCodeVal: "",
				subClassAttrList: [],
				subPanelList: [],
				subClassGridStyle: [],
				popupType: "center",
				check_list: {},

				focusMateria: false,
				head_styledef: {
					form: {
						items: []
					}
				},
				detail1_styledef: {},
				detail1StyleDefList: [],
				activelist: [],
				saving: false,
			};
		},
		onLoad(options) {
			// console.log(options);
			uni.setNavigationBarTitle({
				title: options.titlename
			}); //设置顶部标题 
			this.title = options.titlename;
			this.param = JSON.parse(options.param);
			this.loadData(options.paramValue)

			//页面初始化获取焦点
			// this.focusMateria=true; 
		},
		methods: {
			setData: function(obj) {
				let that = this;
				let keys = [];
				let val, data;

				Object.keys(obj).forEach(function(key) {
					keys = key.split(".");
					val = obj[key];
					data = that.$data;
					keys.forEach(function(key2, index) {
						if (index + 1 == keys.length) {
							that.$set(data, key2, val);
						} else {
							if (!data[key2]) {
								that.$set(data, key2, {});
							}
						}
						data = data[key2];
					});
				});
			},
			async loadData(paramValue) {
				console.log(this.param);
				//获取数据类的自定义表单参数
				await this.Head_UIStyleGetInfo(this.param.Master_Cls?.ID, this.param.Master_Cls?.UI_Style?.ID);
				//传入参数值
				if (paramValue) {
					const attrs = paramValue.attrs || [];

					(this.head_styledef?.form?.items || []).forEach(async (ele, index) => {
						if (ele.name != "Layout") {
							attrs.forEach(async (ele2, index2) => {
								if (ele.fieldId == ele2.name) {
									ele.value = ele2.value;
								}
							});
						} else {
							ele.setting.colList.forEach(async (col) => {
								if (col) {
									attrs.forEach(async (ele2,
										index2) => {
										if (col.fieldId == ele2.name) {
											col.value = ele2.value;
										}
									});
								}
							});
						}
					})
				}

				await this.Detail1_UIstyleGetInfo(this.param.Sub_Cls?.ID, this.param.Sub_Cls?.UI_Style?.ID);
			},
			async Head_UIStyleGetInfo(class_id, style_id) { //获取自定义表单样式
				var $this = this;
				var dataInfo = {
					class_id: class_id,
					ui_style_id: style_id,
				};
				try {
					const result = await getUIStyleInfo(dataInfo)

					var styledef = "";
					if (result.style_def) {
						//mobox2的style_def是json字符串
						styledef = result.style_def.replace(/\\/g, "");
						//mobox3的style_def是base64字符串
						if (!result.style_def.includes('"')) styledef = Base64.decode(result
							.style_def);
					}
					$this.head_styledef = result.style_def ? JSON.parse(styledef) : {};
					// console.log($this.head_styledef);
					if ($this.head_styledef.form?.items) {
						$this.head_styledef.form.items.forEach(async (ele, index) => {
							ele.show = true;
							if (ele.useDict == true) { //判断useDict是否使用字典
								await this.DictGetInfo(ele.bind.dict, index, 'mast');
							} else {
								if (ele?.name === "Select") {
									const selections = ele?.selections || []
									//有默认值，显示默认值
									let itemName = ele.value || "";
									if (itemName) {
										$this.head_styledef.form
											.model[ele.fieldId] = itemName;
									}
									$this.head_styledef.form.items[index].selections = selections.map((
										a) => {
										return {
											value: a.value,
											text: a.label
										}
									})
								}

							}
						});
						const app = getApp()
						if (app.globalData.bindClasses) {
							$this.head_styledef.form.items.push({
								name: "Input",
								label: this.translate("classes"),
								labelWidth: 100,
								disabled: true,
								value: app.globalData.classes,
								setting: {
									width: 100,
									height: 50,
								},
								bind: {
									attr: "",
								},
								fieldId: "S_CLASSES",
							})
							$this.head_styledef.form.model["S_CLASSES"] = app.globalData.classes
						}
					}
					if ($this.head_styledef.event?.length > 0) {
						$this.head_styledef.event.forEach(async (a) => { //判断是否是初始化事件
							if (a.event_id == "initial") {
								await this.loadInitEvent(a.scrip_id, 'head');
							}
						});
					}
				} catch (ex) {
					// console.log(ex);
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : ex
					uni.showModal({
						title: this.translateSys("error") + "1.1",
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}

			},
			async Detail1_UIstyleGetInfo(class_id, style_id) { //获取自定义表单样式
				var $this = this;
				var dataInfo = {
					class_id: class_id,
					ui_style_id: style_id,
				};
				try {
					const result = await getUIStyleInfo(dataInfo)
					var styledef = "";
					if (result.style_def) {
						//mobox2的style_def是json字符串
						styledef = result.style_def.replace(/\\/g, "");
						//mobox3的style_def是base64字符串
						if (!result.style_def.includes('"')) styledef = Base64.decode(result
							.style_def);
					}
					$this.detail1_styledef = result.style_def ? JSON.parse(styledef) : {};
					$this.detail1_styledef.SelBut_Checked = true;
					if ($this.detail1_styledef.form?.items) {
						$this.detail1_styledef.form.items.forEach(async (ele, index) => {
							if (ele.useDict == true) { //判断useDict是否使用字典
								await this.DictGetInfo(ele.bind.dict, index, 'sub');
							} else {
								if (ele?.name === "Select") {
									const selections = ele?.selections || []
									//有默认值，显示默认值
									let itemName = ele.value || "";
									if (itemName) {
										$this.detail1_styledef.form.items[ele.fieldId] = itemName;
									}
									$this.detail1_styledef.form.items[index].selections = selections.map((
										a) => {
										return {
											value: a.value,
											text: a.label
										}
									})
								}
							}
						});
					}
					if ($this.detail1_styledef.event?.length > 0) {
						$detail1_styledefforEach(async (a) => { //判断是否是初始化事件
							if (a.event_id == "initial") {
								await this.loadInitEvent(a.scrip_id, 'detail');
							}
						});
					}
				} catch (ex) {
					// console.log(ex);
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : ex
					uni.showModal({
						title: this.translateSys("error") + "2.1",
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}


			},
			async DictGetInfo(dict, index, type) { //Mobox3得到得到字典信息字典项列表
				this.data = [];
				var $this = this;
				var dataInfo = {
					dict_id: dict.id,
					dict_name: dict.name
				};
				try {
					const result = await dictGetInfo(dataInfo)
					var list = [];
					var itemName = '';
					(result.dict_item_list || []).forEach((item) => {
						if (item.is_default == '1')
							itemName = item.name
						list.push({
							text: item.value ? item.value : item.name,
							value: item.name,
						});
					});

					if (type == 'mast') { //有默认值，显示默认值
						if (itemName) {
							$this.head_styledef.form.items[index].value = itemName;
							var attr = $this.head_styledef.form.items[index].fieldId;
							$this.head_styledef.form.model[attr] = itemName;
						}
						$this.head_styledef.form.items[index].dict = list;
						// console.log($this.detail1StyleDefList);
					} else {
						if (itemName) {
							$this.detail1_styledef.form.items[index].value = itemName;
							var attr = $this.detail1_styledef.form.items[index].fieldId;
							$this.detail1_styledef.form.model[attr] = itemName;
						}
						$this.detail1_styledef.form.items[index].dict = list;
						console.log($this.detail1_styledef);
					}

				} catch (ex) {
					// console.log(ex);
					uni.showModal({
						title: this.translateSys("error") + "1.3",
						content: ex.errMsg,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}

			},
			async loadInitEvent(eventid, type) {
				var $this = this;
				var styledef = type == 'head' ? this.head_styledef : this.detail1_styledef;
				if (!eventid.includes('{')) eventid = '{' + eventid + '}';
				var dataInfo = {
					ed_type: 0,
					start_transaction: true,
					class_id: styledef.form.clsId,
					event_id: eventid,
				};
				console.log(dataInfo);
				// return;
				runCustomEvent(dataInfo).then(data => {
					console.log(data);

					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data.err_info : data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if (this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						} else uni.showModal({
							title: this.translateSys("tip"),
							content: tip + ',' + this.translateSys('tip') + ':' + data.ret,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data.info.join(
							'<br/>') : '';
						if (tip) uni.showModal({
							title: this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: this.translateSys('close')
						});

						var actionlist = data.action;
						if (actionlist) {
							console.log(actionlist);
							for (var i = 0; i < actionlist.length; i++) {
								var action = actionlist[i];
								if (action.action_type == 'set_dlg_attr') {
									var result = action.value;
									for (var i = 0; i < result.length; i++) {
										if (result[i].choice_list) {
											for (var c = 0; c < styledef.form.items.length; c++) {
												var attr = styledef.form.items[c];
												if (attr.name != 'Layout') {
													if (attr.fieldId == result[i].attr) {
														var dictItemList = [];
														for (var d in result[i].choice_list) {
															var val = result[i].choice_list[d];
															dictItemList.push({
																"CN_S_NAME": val,
																"CN_S_VALUE": val,
																"text": val,
																"value": val
															});
														}
														attr.dict = dictItemList;
													}
												} else if (attr.name == 'Layout') {
													attr.setting.colList.forEach(col => {
														if (col) {
															if (col.fieldId == result[i].attr) {
																var dictItemList = [];
																for (var d in result[i]
																		.choice_list) {
																	var val = result[i]
																		.choice_list[d];
																	dictItemList.push({
																		"CN_S_NAME": val,
																		"CN_S_VALUE": val,
																		"text": val,
																		"value": val
																	});
																}
																col.dict = dictItemList;
															}
														}
													});
												}

											}
										}
										for (var c = 0; c < styledef.form.items.length; c++) {
											var attr = styledef.form.items[c];
											// console.log(attr[j].Name+'=='+result[i].attr);
											//判断表单里是否有返回字段，没有就装载到model里，点击确定提交的时候带上这些数据
											if ($this.head_styledef.form.model[result[i].attr] ==
												undefined) {
												$this.head_styledef.form.model[result[i].attr] = result[i]
													.value;
											}
											//判断是否是栅格表单
											if (attr.name != 'Layout') {
												if (attr.fieldId == result[i].attr) {
													attr.value = '';
													attr.oldvalue = '';
													attr.value = result[i].value;
													attr.oldvalue = result[i].value;
													$this.head_styledef.form.model[attr.fieldId] = result[
														i].value;
												}
											} else if (attr.name == 'Layout') {
												attr.setting.colList.forEach(col => {
													if (col) {
														if (col.fieldId == result[i].attr) {
															col.value = '';
															col.oldvalue = '';
															col.value = result[i].value;
															col.oldvalue = result[i].value;
															$this.head_styledef.form.model[col
																.fieldId] = result[i].value;
														}
													}
												});
											}
										}

									}
								} else if (data.action[i].action_type == 'set_dlg_attr_show') {
									var result = action.value;
									if (type == 'head') {
										$this.setFormItemVisible(result)
										// console.log($this.head_styledef);
									} else {
										result.forEach(async (attr, key) => {
											styledef.form.items.forEach(async (ele, index) => {
												//判断是否是栅格表单
												if (ele.name != 'Layout') {
													if (ele.fieldId == attr.attr) {
														ele.show = attr.show;
													}
												} else if (ele.name == 'Layout') {
													ele.setting.colList.forEach(
														col => {
															if (col) {
																if (col.fieldId ==
																	attr.attr) {
																	col.show = attr
																		.show;
																}
															}
														});
												}
											});
										});
										var style_def = JSON.parse(JSON.stringify(styledef));


										$this.detail1_styledef = [];
										$this.detail1_styledef = style_def;
										// console.log($this.detail1_styledef);
									}
								} else {
									uni.showModal({
										title: this.translateSys("tip"),
										content: this.translate('execute_init_event_failed') +
											this.translateSys("full_stop") +
											this.translate('reason') + this.translateSys("colon") +
											this.translateSys("quotation_mark_left") + action
											.action_type + this.translateSys(
												"quotation_mark_right") + this
											.translate('tip_action_unprocessed'),
										showCancel: false,
										confirmText: this.translateSys('close')
									});
								}
							}
						}
					}

				}).catch(ex => {
					// console.log(ex);
					uni.showModal({
						title: this.translateSys("error") + "3.1",
						content: this.translate('execute_init_event_failed') +
							this.translateSys("full_stop") +
							this.translate('reason') + this.translateSys("colon") + ex.errMsg,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				});
			},

			ontap(item) { //扫码功能
				//console.log(e.target)
				getApp().onScan((result) => {
					//console.log(result);
					uni.hideKeyboard();
					var $this = this;
					console.log(item);
					item.value = result
					let newVal = item.value.trim()
					if (newVal) {
						item.oldvalue = newVal;
						var attr = item.fieldId;
						$this.head_styledef.form.model[attr] = newVal;
						$this.focusMateria = true; //初始化，第二个输入框focus属性
						// setTimeout(function(){
						// 	$this.focusMateria=true; //第二个输入框获取焦点
						setTimeout(function() {
							uni.hideKeyboard();
						}, 1000);
						// },500);
						//子数据类扫码区事件脚本
						var eventid = this.param.Scan_Code.Input_Change_Event.ID;
						if (eventid) {
							var obj_attr = this.head_styledef.form.model;
							// console.log(obj_attr);
							var req = Object.keys(obj_attr).map((a) => ({
								attr: a,
								value: obj_attr[a] || "",
							}));
							var info = {
								eventid: eventid,
								edtype: "7", //"0",
								projectid: '',
								rclsid: '',
								robjid: '',
								userlogin: '',
								clsid: 'MBOX', //this.param.Sub_Cls.ID,
								objid: "",
								attr: req,
								mast_attr: [],
								inputParamter: [{
									attr: 'mast_input_3037',
									value: newVal
								}]
							}

							this.scan_DataObjRunCustomEvent(info, "");
						}
					}
				})
			},
			onevent(item) {
				// console.log(e.target);
				var $this = this;
				console.log(item);
				let newVal = item.value
				if (typeof item.value == "string") {
					newVal = item.value.trim()
					if (!newVal) {
						item.oldvalue = newVal;
						var attr = item.fieldId;
						$this.head_styledef.form.model[attr] = newVal;
						return
					}
				}
				if (item.oldvalue != newVal) {
					item.oldvalue = newVal;
					var attr = item.fieldId;
					$this.head_styledef.form.model[attr] = newVal;

					//子数据类扫码区事件脚本
					var eventid = this.param.Scan_Code.Input_Change_Event.ID;
					if (eventid) {
						var obj_attr = this.head_styledef.form.model;
						// console.log(obj_attr);
						var req = Object.keys(obj_attr).map((a) => ({
							attr: a,
							value: obj_attr[a] || "",
						}));
						var info = {
							eventid: eventid,
							edtype: "7", //"0",
							projectid: '',
							rclsid: '',
							robjid: '',
							userlogin: '',
							clsid: 'MBOX', //this.param.Sub_Cls.ID,
							objid: "",
							attr: req,
							mast_attr: [],
							inputParamter: [{
								attr: 'mast_input_3037',
								value: newVal
							}]
						}

						this.scan_DataObjRunCustomEvent(info, "");
					}
				}

			},
			classAttr_extButton(item) {
				var onSuffixClickCallbackEvent = item.bind.onSuffixClickCallbackEvent; //后图标点击回调
				var onSuffixClickEvent = item.bind.onSuffixClickEvent; //后图标点击事件

				if (!onSuffixClickCallbackEvent.id) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate('icon_click_callback_empty'),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				if (!onSuffixClickEvent.id) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate('icon_click_event_empty'),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				this.popupType = 'right'
				// open 方法传入参数 等同在 uni-popup 组件上绑定 type属性
				this.$refs.popup.open(this.popupType);

				this.dataObjRunCustomEvent_Return(onSuffixClickEvent.id, '', onSuffixClickCallbackEvent.id,
					item);
			},
			dataObjRunCustomEvent_Return(eventid, data_attr, button_callback, item) {
				const $this = this
				var enviroment = {
					'function': '3000', // 功能点编号
					cls_id: $this.head_styledef.form.clsId, // 功能点主数据类标识
					'button': 'top', // top/bottom
					button_name: $this.translateSys('add2'),
					master: {
						cls_id: $this.head_styledef.form.clsId, // button=bottom时 master的cls_id
						//obj_id: ''  // button=bottom时 master的obj_id
					}
				};
				var obj_attr = $this.head_styledef.form.model;
				console.log(obj_attr);
				var req = Object.keys(obj_attr).map((a) => ({
					attr: a,
					value: obj_attr[a] || "",
				}));
				if ($this.refdatastore.length > 0) {
					for (var i = 0; i < $this.refdatastore.length; i++) {
						if (!req.filter(function(s) {
								return $this.refdatastore[i].attr == s.name
							}).length) {
							req.push({
								'attr': $this.refdatastore[i].attr,
								'value': $this.refdatastore[i].value
							});
						}
					}
				}

				var extinfo = enviroment;
				extinfo.edit_dlg = {
					type: 'small', //小窗口
					class_id: $this.head_styledef.form.clsId, //当前数据类id
				}
				extinfo = Base64.encode(JSON.stringify(extinfo)); //将字符串转换为base64编码
				var global_attr = Base64.encode(JSON.stringify($this.global_attr)); //将字符串转换为base64编码
				var obj_attr = {};
				req.forEach(item2 => {
					obj_attr[item2.attr] = item2.value;
				});
				let input_param = Base64.encode(
					JSON.stringify(
						Object.keys(obj_attr).map((a) => ({
							attr: a,
							value: obj_attr[a] || "",
						}))
					)
				);

				if (!eventid.includes('{')) eventid = '{' + eventid + '}';
				var dataInfo = {
					ed_type: "0",
					start_transaction: true,
					class_id: $this.head_styledef.form.clsId,
					class_name: '',
					event_id: eventid,
					event_name: '',
					data_obj_id: '',
					obj_attr: obj_attr,
					prj_id: '',
					ref_cls_id: '',
					rel_obj_id: '',
					user_login: '',
					data_json: [],
					compose_info: '',
					ext_info: extinfo,
					global_attr: global_attr,
					input_param: input_param,
				};
				console.log(dataInfo);
				// return;
				runCustomEvent(dataInfo).then(data => {
					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data
							.err_info :
							data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if ($this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: $this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: $this.translateSys('close')
							});
						} else uni.showModal({
							title: $this.translateSys("tip"),
							content: tip + ',' + $this.translateSys('tip') + ':' + data
								.ret,
							showCancel: false,
							confirmText: $this.translateSys('close')
						});
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data
							.info
							.join(
								'<br/>') : '';
						if (tip) uni.showModal({
							title: $this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: $this.translateSys('close')
						});

						if (data != "") {
							var actions = data.action;
							if (actions) {
								for (var i = 0; i < actions.length; i++) {
									var action = actions[i];
									console.log(action)
									var val = action.value;
									var enviroment = JSON.stringify(enviroment);

									if (action.action_type == 'open_panel') {
										var d = dialog({
											title: '<i class="ace-icon fa fa-info-circle"></i> ' +
												$this.translateSys("tip"),
											content: $this.translateSys("quotation_mark_left") +
												action.action_type + $this.translateSys(
													"quotation_mark_right") +
												$this.translate("tip_action_unprocessed")
										});
										d.show();
									} else if (action.action_type == 'open_select_userdlg') {
										var style = val.style;
										// style == 'user' ? '选择人员' : style == 'department' ? '选择部门' : style == 'role' ? '选择角色' : ''
										var param = {
											item: item,
											button_callback: button_callback,
											req: req,
											data_attr: data_attr
										}
										uni.navigateTo({
											url: '../selpsn/index?mulit=false&param=' +
												JSON
												.stringify(
													param),
											events: {
												AddPer(data, param) {
													// console.log(param);
													console.log(data);
													var callback_eventid = param
														.button_callback
														.trim();
													var info = {
														eventid: callback_eventid,
														edtype: "0",
														projectid: '',
														rclsid: '',
														robjid: '',
														userlogin: '',
														clsid: $this.param
															.DataCls
															.id,
														objid: "",
														attr: param.req,
														inputparameter: data,
														dataJson: [],
													}
													$this.DataObjRunCustomEvent(info,
														param
														.data_attr);
												}
											}
										});
									} else if (action.action_type == 'open_data_query_dlg') {
										var d = dialog({
											title: '<i class="ace-icon fa fa-info-circle"></i> ' +
												$this.translateSys("tip"),
											content: $this.translateSys(
													"quotation_mark_left") +
												action
												.action_type + $this.translateSys(
													"quotation_mark_right") + $this
												.translate(
													"tip_action_unprocessed")
										});
										d.show();
									} else if (action.action_type == 'open_common_dlg') {

										if (val.common_dlg_id == 'check_list') {

											$this.setData({
												check_list: val.config
											})
											if (val.config.appear_style == 'sideslip') //判断是否是侧滑
												$this.setData({
													popupType: "right"
												})
											else
												$this.setData({
													popupType: "center"
												})
											// open 方法传入参数 等同在 uni-popup 组件上绑定 type属性
											$this.$refs.popup.open($this.popupType);
											var popupParam = {
												item: item,
												button_callback: button_callback,
												req: req,
												data_attr: data_attr
											}
											$this.setData({
												popupParam: popupParam
											})
										}
									} else if (action.action_type == 'open_project_query_dlg') {
										//console.log(action.value.select_range);
										//console.log(action.value.mulit_select);
										var priRel = '-1';
										if (action.value.select_range == '全部相关')
											priRel = '0';
										else if (action.value.select_range == '我负责的项目')
											priRel = '1';
										else if (action.value.select_range == '我创建的')
											priRel = '2';
										else if (action.value.select_range == '我参与的' || action
											.value
											.select_range == '我参加的')
											priRel = '3';
										else if (action.value.select_range == '我关注的')
											priRel = '4';
										else if (action.value.select_range == '我下属的项目')
											priRel = '5';
										var param_ = {
											item: item,
											button_callback: button_callback,
											req: req
										}
										uni.navigateTo({
											url: '../selPrj/index?relation=' + priRel +
												'&param=' +
												JSON.stringify(param_),
											events: {
												AddPer(data, param) {
													var attr = param.item.fieldId;
													$this.head_styledef.form.model[
															attr] =
														data[0].ID +
														';' + data[0].Name;

													// $this.classAttrList[param.index].Attr[param.iindex].Value=data[0].Name;
													// $this.classAttrList[param.index].Attr[param.iindex].ValID=data[0].ID+';'+data[0].Name;
													var callback_eventid = param
														.button_callback
														.trim();
													if (callback_eventid) {
														var info = {
															eventid: callback_eventid,
															edtype: "2",
															projectid: data[0].ID,
															rclsid: "",
															robjid: "",
															userlogin: "",
															clsid: $this.param
																.DataCls.id,
															objid: "",
															attr: param.req,
															dataJson: [],
														}

														$this.DataObjRunCustomEvent(
															info);
													}
												}
											}
										});
									} else {
										uni.showModal({
											title: $this.translateSys("tip"),
											content: $this.translateSys(
													"quotation_mark_left") +
												action.action_type + $this.translateSys(
													"quotation_mark_right") + $this
												.translate(
													"tip_action_unprocessed"),
											showCancel: false,
											confirmText: $this.translateSys('close')
										});
									}
								}
							}
						} else {
							uni.showModal({
								title: $this.translateSys('tip') + "5.2",
								content: $this.translateSys("quotation_mark_left") +
									"before_click_button" + $this.translateSys(
										"quotation_mark_right") + $this.translateSys(
										"comma") + 'event_id' + eventid,
								showCancel: false,
								confirmText: $this.translateSys('close')
							});
						}
					}

				}).catch(ex => {
					// console.log(ex);
					let exStr = JSON.stringify(ex)
					if (exStr == "{}")
						exStr = ex
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : exStr
					uni.showModal({
						title: $this.translateSys('tip') + "5.1",
						content: exStr,
						showCancel: false,
						confirmText: $this.translateSys('close')
					});
				});
			},

			onEnterChange(item) {
				console.log("onEnterChange", item);
				let newVal = item.value
				if (typeof item.value == "string") {
					newVal = item.value.trim()
					if (!newVal)
						return
				}
				if (item.oldvalue != newVal) {
					item.oldvalue = newVal;
					var attr = item.fieldId;
					this.head_styledef.form.model[attr] = newVal;
					var onChangeEvent = item.bind.onChangeEvent; //内容变化后事件
					if (onChangeEvent?.id) { //内容变化后事件
						this.onChange(onChangeEvent);
					}
				}

			},
			onDetail1EnterChange(item) {
				//码盘中样式回车事件
				// console.log(item);
			},
			// 内容变化后事件
			async onChange(event) {
				var eventid = event?.id; //内容变化后事件
				if (eventid) {
					// self.event_no_sub = 1;
					var obj_attr = this.head_styledef.form.model;
					// console.log(obj_attr);
					var req = Object.keys(obj_attr).map((a) => ({
						attr: a,
						value: obj_attr[a] || "",
					}));
					var info = {
						eventid: eventid,
						edtype: "0",
						projectid: '',
						rclsid: '',
						robjid: '',
						userlogin: '',
						clsid: this.head_styledef.form.clsId,
						objid: "",
						attr: req,
					}
					this.DataObjRunCustomEvent(info);
				}

			},

			scan_ontap(e) { //扫码区扫码功能
				//console.log(e.target)
				getApp().onScan((result) => {
					console.log(result);
					item.value = result
					let newVal = item.value
					if (typeof item.value == "string") {
						newVal = item.value.trim()
					}
					var isflag = true;
					for (var i in this.subPanelList) {
						if (this.subPanelList[i].scanCodeVal == newVal)
							isflag = false;
					}
					//子数据类扫码查询数据
					if (isflag) {
						uni.hideKeyboard();
						this.scanCodeVal = newVal;
						var eventid = this.param.Scan_Code.Input_Change_Event.ID;
						if (eventid) {
							//主数据类属性
							var obj_attr = this.head_styledef.form.model;
							// console.log(obj_attr);
							var mast_req = Object.keys(obj_attr).map((a) => ({
								attr: a,
								value: obj_attr[a] || "",
							}));
							var obj_attr2 = this.detail1_styledef.form.model;
							var req = Object.keys(obj_attr2).map((a) => ({
								attr: a,
								value: obj_attr2[a] || "",
							}));

							var info = {
								eventid: eventid,
								edtype: '7', //"0",
								projectid: '',
								rclsid: '',
								robjid: '',
								userlogin: '',
								clsid: 'MBOX', //this.param.Sub_Cls.ID,
								objid: "",
								attr: mast_req,
								sub_attr: req,
								inputParamter: [{
									attr: 'input_3037',
									value: this.scanCodeVal
								}]
							}

							this.scan_DataObjRunCustomEvent(info, "");
						}
					}
				})
			},
			scan_onevent(e) {
				// console.log(e.target);
				if (e.detail.value) {
					var isflag = true;
					for (var i in this.subPanelList) {
						if (this.subPanelList[i].scanCodeVal == e.detail.value)
							isflag = false;
					}
					//子数据类扫码查询数据
					if (isflag) {
						uni.hideKeyboard();
						this.scanCodeVal = e.detail.value;
						var eventid = this.param.Scan_Code.Input_Change_Event.ID;
						if (eventid) {
							//主数据类属性
							var obj_attr = this.head_styledef.form.model;
							// console.log(obj_attr);
							var mast_req = Object.keys(obj_attr).map((a) => ({
								attr: a,
								value: obj_attr[a] || "",
							}));
							// var input_param = Base64.encode(
							//   JSON.stringify(
							//     Object.keys(obj_attr).map((a) => ({
							//       attr: a,
							//       value: obj_attr[a] || "",
							//     }))
							//   )
							// );
							var obj_attr2 = this.detail1_styledef.form.model;
							var req = Object.keys(obj_attr2).map((a) => ({
								attr: a,
								value: obj_attr2[a] || "",
							}));
							var info = {
								eventid: eventid,
								edtype: '7', //"0",
								projectid: '',
								rclsid: '',
								robjid: '',
								userlogin: '',
								clsid: 'MBOX', //this.param.Sub_Cls.ID,
								objid: "",
								attr: mast_req,
								sub_attr: req,
								inputParamter: [{
									attr: 'input_3037',
									value: this.scanCodeVal
								}]
							}

							this.scan_DataObjRunCustomEvent(info, "");
						}
					}
				}
			},

			panel_del(index) { //面板删除
				var $this = this;
				if (this.subPanelList[index].scanCodeVal == this.scanCodeVal) {
					this.scanCodeVal = '';
				}
				if (!this.subPanelList[index].ObjID)
					this.subPanelList.splice(index, 1);
				else {
					var dataInfo = {
						class_id: this.param.Sub_Cls.ID,
						class_name: '',
						obj_id: this.subPanelList[index].ObjID
					};
					// console.log(dataInfo);
					// return;
					uni.showLoading({
						title: this.translateSys("loading")
					});
					dataObjDel(dataInfo).then(success => {
						// console.log(success);
						uni.hideLoading();

						$this.subPanelList.splice(index, 1);
						uni.showModal({
							title: this.translateSys("tip"),
							content: this.translate("delete_success"),
							showCancel: false,
							confirmText: this.translateSys('close')
						});

					}).catch(ex => {
						console.log(ex);
						uni.hideLoading();
						uni.showModal({
							title: this.translateSys('tip') + "9.1",
							content: ex.errMsg,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
					});
				}
			},
			scan_classAttr_extButton(e) { //选择按钮前
				var $this = this;
				var Before_Select_Event = $this.param.Scan_Code.Before_Select_Event;
				if (!Before_Select_Event) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate("before_select_event_empty"),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				var obj_attr = this.head_styledef.form.model;
				// console.log(obj_attr);
				var mast_attr = Object.keys(obj_attr).map((a) => ({
					attr: a,
					value: obj_attr[a] || "",
				}));
				var objects = [];
				var subPanelList = $this.subPanelList;
				for (var s = 0; s < subPanelList.length; s++) {
					var detail_attr = {};
					subPanelList[s].subClassAttr.form.items.forEach(item => {
						if (item.name == "Layout") { //判断是否是栅栏格式
							item.setting.colList.forEach(cols => {
								if (cols != null) detail_attr[cols.fieldId] = cols.value;
							});
						} else
							detail_attr[item.fieldId] = item.value;
					});
					var sub_req = Object.keys(detail_attr).map((a) => ({
						attr: a,
						value: detail_attr[a] || "",
					}));
					objects.push({
						obj_id: subPanelList[s].scanCodeVal,
						obj_attrs: sub_req
					});
				}

				var req = [];
				var enviroment = {
					'function': '3000', // 功能点编号
					cls_id: 'MBOX', //this.param.Sub_Cls.ID,     // 功能点从数据类标识
					'button': 'top', // top/bottom
					button_name: this.translateSys('add2'),
					edit_dlg: {
						type: 'small', //小窗口
						class_id: 'MBOX', //this.param.Sub_Cls.ID,//当前数据类id
					},
					master_cls: {
						cls_name: 'MBOX', //$this.param.Master_Cls.Name,
						obj_attrs: mast_attr
					},
					sub_cls: {
						cls_name: 'MBOX', //$this.param.Sub_Cls.Name,
						objects: objects
					}

				};

				var info = {
					eventid: Before_Select_Event.ID,
					edtype: "7", //"0",
					projectid: '',
					rclsid: '',
					robjid: '',
					userlogin: '',
					clsid: 'MBOX', //this.param.Sub_Cls.ID,
					objid: "",
					attr: [],
					global_attr: req,
					mast_attr: mast_attr,
					inputParamter: mast_attr,
					enviroment: enviroment
				}
				// console.log(info);
				this.scan_DataObjRunCustomEvent(info, "");
			},
			popupChange(e) {
				console.log('当前模式：' + e.type + ',状态：' + e.show);
			},
			checkChange(e) { //弹框check选择
				// console.log(e.target.dataset);
				var index = e.target.dataset.index;
				var ischeck = e.target.dataset.ischeck;
				var data = this.check_list.items;
				// this.check_list.items=[];
				if (this.check_list.multiple_choice == "0") { //判断时单选还是多选
					for (var i in data) {
						data[i].check = false;
					}
				}
				data[index].check = ischeck ? false : true;
				this.check_list.items = data;

			},
			popup_cancel(e) { //弹框取消
				this.$refs.popup.close();
			},
			popup_sava(e) { //弹框确定 选择按钮后
				var $this = this;
				var After_Select_Event = $this.param.Scan_Code.After_Select_Event;
				if (!After_Select_Event) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate("after_select_event_empty"),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				var items = $this.check_list.items;
				var data = [];
				var name = "";
				for (var i = 0; i < items.length; i++) {
					if (items[i].check == true) {
						if (name)
							name += ';';
						name += items[i].name;
						data.push({
							id: items[i].id,
							name: items[i].name
						});
					}
				}
				if (data.length == 0) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate("tip_no_select_data"),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				var obj_attr = this.head_styledef.form.model;
				// console.log(obj_attr);
				var mast_attr = Object.keys(obj_attr).map((a) => ({
					attr: a,
					value: obj_attr[a] || "",
				}));

				$this.scanCodeVal = name;
				var info = {
					eventid: After_Select_Event.ID,
					edtype: "7",
					projectid: '',
					rclsid: '',
					robjid: '',
					userlogin: '',
					clsid: 'MBOX',
					objid: "",
					attr: [{
						attr: 'mast_input_3037',
						value: name
					}],
					global_attr: mast_attr,
					inputParamter: data,
					enviroment: ''
				}
				// console.log(info);
				this.scan_DataObjRunCustomEvent(info, "");
				this.$refs.popup.close();
			},
			onPanelClick(value) { //点击面板高亮显示
				// console.log(value);
				this.activelist.forEach(ele => {
					ele.active = false;
				});
				this.activelist[value].active = true;
			},

			DataObjRunCustomEvent(info, data_attr) {
				var $this = this;
				var enviroment = {
					'function': '3000', // 功能点编号
					cls_id: this.param.Master_Cls.ID, // 功能点主数据类标识
					'button': 'top', // top/bottom
					button_name: this.translateSys('add2'),
					master: {
						cls_id: this.param.Master_Cls.ID, // button=bottom时 master的cls_id
						//obj_id: ''  // button=bottom时 master的obj_id
					}
				};
				enviroment.edit_dlg = {
					type: 'small', //小窗口
					class_id: this.param.Master_Cls.ID, //当前数据类id
				}
				if (data_attr) {
					enviroment.edit_dlg.form_control = { //所属的表单控件
						name: data_attr.Name, //字段属性
						text: data_attr.DispName, //显示文本
						group_name: data_attr.GroupName, //属性组
						type: data_attr.Type, //字段类型
						readonly: data_attr.ReadOnly, //是否只读
						button_img: data_attr.button_img, //引用按钮的图标
						button_tooltip: data_attr.button_tooltip //引用按钮的tooltip
					}
				}
				// var dataInfo = {
				//        edtype: info.edtype, eventid: info.eventid, projectid: info.projectid.replace('{','').replace('}',''),
				//        rclsid: info.rclsid, robjid: info.robjid, userlogin: info.userlogin, clsid: info.clsid, objid: info.objid,
				//        attr: JSON.stringify(info.attr), extinfo: JSON.stringify(enviroment), inputparameter: '', global_attr: JSON.stringify(this.global_attr)
				//    }
				enviroment = Base64.encode(JSON.stringify(enviroment)); //将字符串转换为base64编码
				var global_attr = Base64.encode(JSON.stringify(this.global_attr)); //将字符串转换为base64编码
				if (info.dataJson)
					info.dataJson = Base64.encode(JSON.stringify(info.dataJson)); //将字符串转换为base64编码
				var obj_attr = {};
				info.attr.forEach(item => {
					obj_attr[item.attr] = item.value;
				});
				if (!info.eventid.includes('{')) info.eventid = '{' + info.eventid + '}';
				var dataInfo = {
					ed_type: info.edtype,
					start_transaction: true,
					class_id: info.clsid,
					class_name: '',
					event_id: info.eventid,
					event_name: '',
					data_obj_id: info.objid,
					obj_attr: obj_attr,
					prj_id: info.projectid,
					ref_cls_id: info.rclsid,
					rel_obj_id: info.robjid,
					user_login: info.userlogin,
					data_json: info.dataJson,
					compose_info: '',
					ext_info: enviroment,
					global_attr: global_attr,
					input_param: '',
				};
				console.log(dataInfo);
				// return;
				runCustomEvent(dataInfo).then(data => {
					console.log(data);
					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data.err_info : data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if (this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						} else uni.showModal({
							title: this.translateSys("tip"),
							content: tip + ',' + this.translateSys('tip') + ':' + data.ret,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data.info.join(
							'<br/>') : '';
						if (tip) uni.showModal({
							title: this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: this.translateSys('close')
						});

						var actionlist = data.action;
						if (actionlist) {
							console.log(actionlist);
							for (var i = 0; i < actionlist.length; i++) {
								var action = actionlist[i];
								if (action.action_type == 'set_dlg_attr') {
									var result = action.value;
									for (var i = 0; i < result.length; i++) {
										if (result[i].choice_list) {
											for (var c = 0; c < $this.head_styledef.form.items.length; c++) {
												var attr = $this.head_styledef.form.items[c];
												if (attr.name != 'Layout') {
													if (attr.fieldId == result[i].attr) {
														var dictItemList = [];
														for (var d in result[i].choice_list) {
															var val = result[i].choice_list[d];
															dictItemList.push({
																"CN_S_NAME": val,
																"CN_S_VALUE": val,
																"text": val,
																"value": val
															});
														}
														attr.dict = dictItemList;
													}
												} else if (attr.name == 'Layout') {
													attr.setting.colList.forEach(col => {
														if (col) {
															if (col.fieldId == result[i].attr) {
																var dictItemList = [];
																for (var d in result[i].choice_list) {
																	var val = result[i].choice_list[d];
																	dictItemList.push({
																		"CN_S_NAME": val,
																		"CN_S_VALUE": val,
																		"text": val,
																		"value": val
																	});
																}
																col.dict = dictItemList;
															}
														}
													});
												}
											}
										}
										for (var c = 0; c < $this.head_styledef.form.items.length; c++) {
											var attr = $this.head_styledef.form.items[c];
											// console.log(attr[j].Name+'=='+result[i].attr);
											if (attr.name != 'Layout') {
												if (attr.fieldId == result[i].attr) {
													attr.value = '';
													attr.oldvalue = '';
													attr.value = result[i].value;
													attr.oldvalue = result[i].value;
													$this.head_styledef.form.model[attr.fieldId] = result[i]
														.value;
												}
											} else if (attr.name == 'Layout') {
												attr.setting.colList.forEach(col => {
													if (col) {
														if (col.fieldId == result[i].attr) {
															col.value = '';
															col.oldvalue = '';
															col.value = result[i].value;
															col.oldvalue = result[i].value;
															$this.head_styledef.form.model[col
																.fieldId] = result[i].value;
														}
													}
												});
											}

										}

									}
								} else if (action.action_type == 'set_dlg_attr_show') {
									var data = action.value;
									$this.setFormItemVisible(data)
									// console.log($this.head_styledef);
								} else if (action.action_type == 'set_global_attr') {
									$this.global_attr = action.value || [];
								}

							}
						}

						if (data.result) {
							var result = data.result;
							for (var i = 0; i < result.length; i++) {
								for (var c = 0; c < $this.head_styledef.form.items.length; c++) {
									var attr = $this.head_styledef.form.items[c];
									if (attr.name != 'Layout') {
										if (attr.fieldId == result[i].attr) {
											attr.value = '';
											attr.oldvalue = '';
											attr.value = result[i].value;
											attr.oldvalue = result[i].value;
											$this.head_styledef.form.model[attr.fieldId] = result[i].value;
										}
									} else if (attr.name == 'Layout') {
										attr.setting.colList.forEach(col => {
											if (col) {
												if (col.fieldId == result[i].attr) {
													col.value = '';
													col.oldvalue = '';
													col.value = result[i].value;
													col.oldvalue = result[i].value;
													$this.head_styledef.form.model[col.fieldId] =
														result[i].value;
												}
											}
										});
									}

								}

								var length = 0;
								if (!$this.refdatastore.filter(function(s) {
										return result[i].attr == s.attr
									}).length) {
									length = 1;
									$this.refdatastore.push(result[i]);
								}
								if (length == 0) {
									for (var j = 0; j < $this.refdatastore.length; j++) {
										if ($this.refdatastore[j].attr == result[i].attr) {
											$this.refdatastore[j].value = result[i].value;
										}
									}
								}
							}
						}
					}

				}).catch(ex => {
					// console.log(ex);
					uni.showModal({
						title: this.translateSys("error") + "3.1",
						content: ex.errMsg,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				});
			},
			setFormItemVisible(attrs) {
				if (!Array.isArray(attrs)) {
					return
				}
				const head_styledef = this.head_styledef
				if (!head_styledef.hiddenIds) {
					head_styledef.hiddenIds = []
				}
				attrs.forEach((attr) => {
					let index = head_styledef.hiddenIds.findIndex((id) => id == attr.attr);
					if (attr.show) {
						if (index > -1) head_styledef.hiddenIds.splice(index, 1);
					} else {
						if (index == -1) head_styledef.hiddenIds.push(attr.attr);
					}
				});

				this.setData({
					head_styledef: head_styledef
				})
			},
			scan_DataObjRunCustomEvent(info, data_attr) {
				var $this = this;
				var obj_attr = {};
				info.attr.forEach(item => {
					obj_attr[item.attr] = item.value;
				});
				var enviroment = {};
				if (info.enviroment) {
					enviroment = info.enviroment;
				} else {
					enviroment = {
						'function': '3000', // 功能点编号
						cls_id: 'MBOX', //this.param.Sub_Cls.ID,     // 功能点从数据类标识
						'button': 'top', // top/bottom
						button_name: this.translateSys('add2'),
						edit_dlg: {
							type: 'small', //小窗口
							class_id: 'MBOX', //this.param.Sub_Cls.ID,//当前数据类id
						},
						master: {
							cls_id: info.clsid, // button=bottom时 master的cls_id
							//obj_id: ''  // button=bottom时 master的obj_id
							obj_attrs: obj_attr,
						}
					};

				}
				var global_attr = this.global_attr;
				if (info.global_attr) {
					global_attr = info.global_attr;
				}

				enviroment = Base64.encode(JSON.stringify(enviroment)); //将字符串转换为base64编码
				var inputParamter = info.inputParamter;
				if (info.inputParamter) {
					info.inputParamter = Base64.encode(JSON.stringify(info.inputParamter)); //将字符串转换为base64编码
				}
				var global_attr = Base64.encode(JSON.stringify(this.global_attr)); //将字符串转换为base64编码

				if (!info.eventid.includes('{')) info.eventid = '{' + info.eventid + '}';
				var dataInfo = {
					ed_type: info.edtype,
					start_transaction: true,
					class_id: info.clsid,
					class_name: '',
					event_id: info.eventid,
					event_name: '',
					data_obj_id: info.objid,
					obj_attr: obj_attr,
					prj_id: info.projectid.replace('{', '').replace('}', ''),
					ref_cls_id: info.rclsid,
					rel_obj_id: info.robjid,
					user_login: info.userlogin,
					data_json: '',
					compose_info: '',
					ext_info: enviroment,
					global_attr: global_attr,
					input_param: info.inputParamter,
				};
				console.log(dataInfo);
				// return;
				runCustomEvent(dataInfo).then(data => {
					console.log(data);

					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data.err_info : data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if (this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						} else uni.showModal({
							title: this.translateSys("tip"),
							content: tip + this.translateSys('comma') + this.translate('result') + this
								.translateSys('colon') + data.ret,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data.info.join(
							'<br/>') : '';
						if (tip) uni.showModal({
							title: this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: this.translateSys('close')
						});

						var actionlist = data.action;
						if (actionlist) {
							console.log(actionlist);
							for (var ii = 0; ii < actionlist.length; ii++) {
								var action = actionlist[ii];
								if (action.action_type == 'set_dlg_attr') {
									var result = action.value;
									for (var i = 0; i < result.length; i++) {
										if (result[i].choice_list) {
											for (var s = 0; s < $this.subPanelList.length; s++) {
												for (var c = 0; c < $this.subPanelList[s]
													.subClassAttrList.length; c++) {
													var attr = $this.subPanelList[s].subClassAttrList[c]
														.Attr;
													for (var j = 0; j < attr.length; j++) {
														if (attr[j].Name == result[i].attr) {
															if (utils.classUtils.attrTypeIsDict(attr[j]
																	.Type)) {
																var dictItemList = [];
																for (var d in result[i].choice_list) {
																	var val = result[i].choice_list[d];
																	dictItemList.push({
																		"CN_S_NAME": val,
																		"CN_S_VALUE": val,
																		"Name": val,
																		"label": val,
																		"value": val
																	});
																}
																attr[j].dictitem = dictItemList;
																// attr[j].dictitem = result[i].choice_list;
															}
														}
													}
												}
											}
										}
										for (var s = 0; s < $this.subPanelList.length; s++) {
											for (var c = 0; c < $this.subPanelList[s].subClassAttrList
												.length; c++) {
												var attr = $this.subPanelList[s].subClassAttrList[c]
													.Attr;
												for (var j = 0; j < attr.length; j++) {
													console.log(attr[j].Name + '==' + result[i].attr);
													if (attr[j].Name == result[i].attr) {
														attr[j].Value = result[i].value;
														// attr.value = '';
														// attr.oldvalue = '';
														// attr.value = result[i].value;
														// attr.oldvalue = result[i].value;
													}
												}
											}
										}
										var length = 0;

									}
								} else if (action.action_type == 'set_global_attr') {
									$this.$actiontr = action.value || [];
								} else if (action.action_type == 'open_common_dlg') { //打开侧滑弹框
									var $this = this;
									if (action.value.common_dlg_id == 'check_list') {
										$this.check_list = action.value.config;
										if (action.value.config.appear_style == 'sideslip') //判断是否是侧滑
											$this.popupType = 'right';
										else
											$this.popupType = 'center'
										// open 方法传入参数 等同在 uni-popup 组件上绑定 type属性
										$this.$refs.popup.open($this.popupType);
									}
								} else if (action.action_type == 'add_subcls_panel') { //主从数据类扫码查询数据
									var result = action.value;
									var $this = this;
									var list_1 = JSON.parse(JSON.stringify(this.detail1_styledef));
									var scanCodeVal = $this.scanCodeVal;
									var rand = '';
									for (var i = 0; i < 5; i++) { //生成5位随机数
										rand += Math.floor(Math.random() * 10);
									}
									if (inputParamter[0].attr) {
										if (inputParamter[0].attr == "mast_input_3037") //判断是主数据类扫码查询数据
											scanCodeVal = "mast_input_3037-" + rand;
									}
									if (info.attr[0].attr) {
										if (info.attr[0].attr == "mast_input_3037") //判断是主数据类扫码查询数据
											scanCodeVal = "mast_input_3037-" + rand;
									}
									$this.subPanelList.push({
										scanCodeVal: scanCodeVal,
										subClassAttr: list_1
									});
									$this.activelist.push({
										active: false
									});
									for (var i = 0; i < result.length; i++) {
										for (var s = 0; s < $this.subPanelList.length; s++) {
											if ($this.subPanelList[s].scanCodeVal == scanCodeVal) {
												if (result[i].attr == "S_ID")
													$this.subPanelList[s].ObjID = result[i].value;
												var _subClassAttr = $this.subPanelList[s].subClassAttr
													.form.items;
												for (var c = 0; c < _subClassAttr.length; c++) {
													if (_subClassAttr[c].name != 'Layout') {
														if (_subClassAttr[c].fieldId == result[i].attr)
															_subClassAttr[c].value = result[i].value;
													} else if (_subClassAttr[c].name == 'Layout') {
														_subClassAttr[c].setting.colList.forEach(col => {
															if (col) {
																if (col.fieldId == result[i].attr)
																	col.value = result[i].value;
															}
														});
													}
												}

												// $this.subPanelList[s].subClassAttr=list_1;
											}
										}
										// console.log($this.subPanelList);
										var length = 0;
										if (!$this.refdatastore.filter(function(s) {
												return result[i].attr == s.attr
											}).length) {
											length = 1;
											$this.refdatastore.push(result[i]);
										}
										if (length == 0) {
											for (var j = 0; j < $this.refdatastore.length; j++) {
												if ($this.refdatastore[j].attr == result[i].attr) {
													$this.refdatastore[j].value = result[i].value;
												}
											}
										}
									}
								} else {
									uni.showModal({
										title: this.translateSys("tip"),
										content: this.translateSys("quotation_mark_left") + action
											.action_type + this.translateSys(
												"quotation_mark_right") + this.translate(
												"tip_action_unprocessed"),
										showCancel: false,
										confirmText: this.translateSys('close')
									});
								}
							}
						}

						if (data.result) {
							var list_1 = JSON.parse(JSON.stringify(this.detail1_styledef));
							var scanCodeVal = $this.scanCodeVal;
							var rand = '';
							for (var i = 0; i < 5; i++) { //生成5位随机数
								rand += Math.floor(Math.random() * 10);
							}
							if (inputParamter[0].attr) {
								if (inputParamter[0].attr == "mast_input_3037") //判断是主数据类扫码查询数据
									scanCodeVal = "mast_input_3037-" + rand;
							}
							if (info.attr[0].attr) {
								if (info.attr[0].attr == "mast_input_3037") //判断是主数据类扫码查询数据
									scanCodeVal = "mast_input_3037-" + rand;
							}
							$this.subPanelList.push({
								scanCodeVal: scanCodeVal,
								subClassAttr: list_1
							});
							var result = data.result;
							for (var i = 0; i < result.length; i++) {
								for (var s = 0; s < $this.subPanelList.length; s++) {
									if ($this.subPanelList[s].scanCodeVal == scanCodeVal) {
										if (result[i].attr == "S_ID")
											$this.subPanelList[s].ObjID = result[i].value;
										var _subClassAttr = $this.subPanelList[s].subClassAttr.form
											.items;
										for (var c = 0; c < _subClassAttr.length; c++) {
											if (_subClassAttr[c].name != 'Layout') {
												if (_subClassAttr[c].fieldId == result[i].attr)
													_subClassAttr[c].value = result[i].value;
											} else if (_subClassAttr[c].name == 'Layout') {
												_subClassAttr[c].setting.colList.forEach(col => {
													if (col) {
														if (col.fieldId == result[i].attr)
															col.value = result[i].value;
													}
												});
											}
										}
									}
								}

								var length = 0;
								if (!$this.refdatastore.filter(function(s) {
										return result[i].attr == s.attr
									}).length) {
									length = 1;
									$this.refdatastore.push(result[i]);
								}
								if (length == 0) {
									for (var j = 0; j < $this.refdatastore.length; j++) {
										if ($this.refdatastore[j].attr == result[i].attr) {
											$this.refdatastore[j].value = result[i].value;
										}
									}
								}
							}
						}
					}

				}).catch(ex => {
					// console.log(ex);
					uni.showModal({
						title: this.translateSys("error") + "7.1",
						content: ex.errMsg,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				});
			},
			onSave() {
				this.handleButtonClick((done) => {
					this.sava()
					setTimeout(() => {
						done(); // 重置状态
					}, 1000);
				});
			},
			//确定
			sava() {
				if (this.param.Before_OK_Event) //判断功能点参数是否有确定前脚本
					this.scan_OKDataObjRunCustomEvent(this.param.Before_OK_Event.ID);
				else if (this.param.After_OK_Event) //判断功能点参数是否有确定后脚本
					this.scan_OKDataObjRunCustomEvent(this.param.After_OK_Event.ID);
				else
					uni.navigateBack({
						delta: 1
					}); //返回层数，2则上上页
			},
			scan_OKDataObjRunCustomEvent(eventID) {
				this.saving = true
				uni.showLoading({
					title: this.translateSys("loading"),
					mask: true
				});
				var $this = this;
				//获取表头属性
				var obj_attr = this.head_styledef.form.model;
				// console.log(obj_attr);
				var req = Object.keys(obj_attr).map((a) => ({
					attr: a,
					value: obj_attr[a] || "",
				}));

				var objects = [];
				var subPanelList = $this.subPanelList;
				for (var s = 0; s < subPanelList.length; s++) {
					var detail_attr = {};
					subPanelList[s].subClassAttr.form.items.forEach(item => {
						if (item.name == "Layout") { //判断是否是栅栏格式
							item.setting.colList.forEach(cols => {
								if (cols != null) detail_attr[cols.fieldId] = cols.value;
							});
						} else
							detail_attr[item.fieldId] = item.value;
					});
					var sub_req = Object.keys(detail_attr).map((a) => ({
						attr: a,
						value: detail_attr[a] || "",
					}));
					objects.push({
						obj_id: subPanelList[s].scanCodeVal,
						obj_attrs: sub_req
					});
				}

				var dataJson = {
					master_cls: {
						cls_name: 'MBOX', //$this.param.Master_Cls.Name,
						obj_attrs: req
					},
					input_3037: $this.scanCodeVal, //扫码内容
					op_type: $this.param.OperationType, //作业类型定义
					sub_cls: {
						cls_name: 'MBOX', //$this.param.Sub_Cls.Name,
						objects: objects
					}
				};
				// console.log(JSON.stringify(dataJson));
				var dataJson = Base64.encode(JSON.stringify(dataJson)); //将字符串转换为base64编码
				var global_attr = Base64.encode(JSON.stringify(this.global_attr)); //将字符串转换为base64编码
				if (!eventID.includes('{')) eventID = '{' + eventID + '}';
				var dataInfo = {
					ed_type: "7",
					start_transaction: true,
					class_id: 'MBOX',
					class_name: '',
					event_id: eventID,
					event_name: '',
					data_obj_id: '',
					obj_attr: '',
					prj_id: '',
					ref_cls_id: '',
					rel_obj_id: '',
					user_login: '',
					data_json: dataJson,
					compose_info: '',
					ext_info: '',
					global_attr: global_attr,
					input_param: '',
				};
				console.log(dataInfo);
				// uni.hideLoading();
				// 	return;
				runCustomEvent(dataInfo).then(data => {
					console.log(data);
					uni.hideLoading();
					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data.err_info : data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if (this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						} else uni.showModal({
							title: this.translateSys("tip"),
							content: tip + ',' + this.translateSys('tip') + ':' + data.ret,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						this.saving = false
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data.info.join(
							'<br/>') : '';
						if (tip) uni.showModal({
							title: this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: this.translateSys('close')
						});

						var result = data.result;
						if (eventID != $this.param.After_OK_Event.ID)
							$this.scan_OKDataObjRunCustomEvent($this.param.After_OK_Event.ID);
						else {
							//刷新
							uni.redirectTo({
								url: '../modal/3037_2?param=' + JSON.stringify($this.param) +
									"&titlename=" + $this.title
							});
						}
					}

					this.saving = false
				}).catch(ex => {
					// console.log(ex);
					this.saving = false
					uni.hideLoading();
					uni.showModal({
						title: this.translateSys("error") + "8.1",
						content: ex.errMsg,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				});
			},


			cancel(e) { //取消
				uni.navigateBack({
					delta: 1 //返回层数，2则上上页
				});
			},
			translate(t) {
				if (typeof this.$t == "function") return this.$t(`page.modal.${t}`)
				else return t;
			},
			translateSys(t) {
				if (typeof this.$t == "function") return this.$t(`sys.${t}`)
				else return t;
			},
		},
	};
</script>
<style>
	.popup-content {
		@include flex;
	}

	.popup-height {
		@include height;
		/* width: 200px; */
	}
</style>
<style lang="scss">
	.uni-page-modal-3017-2 {


		.v-headStyle {
			/* border: 1px solid red; */
		}

		.v-headStyle:first-child {
			margin-top: 15rpx;
		}

		.v-headStyle .txt_title {
			font-size: 34rpx;
			text-align: right;
			display: inline-block;
			vertical-align: 12px;
		}

		.v-headStyle input {
			display: inline-block;
			/* border: 1px solid #d5d5d5; */
			/* width: 65%; */
			width: 85%;
			height: 52rpx;
			line-height: 34rpx;
			background: #FFF;
			border-radius: 0 !important;
			color: #2d8cf0;
			padding: 10rpx 8rpx 12rpx;
			font-size: 34rpx;
			font-family: inherit;
			box-shadow: none !important;
			transition-duration: 0.1s;
			margin-top: 4rpx;
		}

		.v-headStyle input::-webkit-input-placeholder {
			font-size: 12rpx;
		}

		.input-wrapper {
			border: 1px solid #d5d5d5;
			display: inline-block;
			width: 65%;
			line-height: 22rpx;
		}

		[nvue] uni-view {
			position: relative;
			border: 0 solid #000;
			box-sizing: border-box;
		}

		.uni-input {
			/* border: none; */
		}

		.uni-icon {
			/* border: 1px solid red; */
			width: 30rpx;
			padding: 10rpx 5rpx;
			font-family: uniicons;
			font-size: 40rpx;
			font-weight: 400;
			font-style: normal;
			/* width: 48rpx; */
			height: 48rpx;
			line-height: 48rpx;
			color: #2d8cf0;
			cursor: pointer;
			display: inline-block;
			vertical-align: 18rpx;
		}


		.view-content {
			min-height: 700rpx;
			/* border:1px solid red; */
		}

		.dv-panel {
			/* padding: 10rpx 20rpx 4rpx 0px; */
			border-radius: 12rpx;
			/* margin-bottom: 20rpx; */

			.uni-forms-item {
				padding-bottom: 5rpx;
				margin-bottom: 0;

				.uni-forms-item__label {
					height: 20px !important;
					padding: 0 10rpx 0 0 !important;
				}

				.uni-input {
					width: calc(100% - 12rpx);
					padding: 5rpx;
					border: 1px solid #d5d5d5;
					color: #2d8cf0;
					height: 20px;
					background: #FFF;
					line-height: 20px;
					border-radius: 6px !important;
					font-size: 14px;
					font-family: inherit;
					box-shadow: none !important;
					transition-duration: 0.1s;
					vertical-align: middle;
				}

				.uni-input:hover {
					border: 1px solid rgb(41, 121, 255);
				}
			}



		}

		.dv-panel:first-child {
			padding-top: 10rpx;
		}



		#dv_select {
			display: inline-block;
			width: 66%;
			background: #FFF;
			border-radius: 0 !important;
			color: #2d8cf0;
			/* padding: 10rpx 8rpx 12rpx; */
			font-size: 34rpx;
			font-family: inherit;
			box-shadow: none !important;
			transition-duration: 0.1s;
			margin-top: 0rpx;
			vertical-align: 10px;
		}

		#dv_select .uni-select {
			border: 1px solid #ccc;
			border-radius: 0 !important;
			color: #2d8cf0;
		}

		#dv_select .uni-select__input-text {
			color: #2d8cf0;
		}

		.panel_title {
			font-size: 38rpx;
			background-color: #27A6E1;
			line-height: 80rpx;
			color: #fff;
			text-align: center;
			font-weight: bold;
		}

		.v-panel {
			min-height: 770rpx;
		}

		.v-panellist {
			background-color: #efefef;
			border: 4rpx solid #aaa;
			border-radius: 10rpx;
			margin: 10rpx 10rpx 0rpx 20rpx;
		}

		.v-paneldel {
			text-align: right;
		}

		.panel_del {
			font-size: 44rpx;
			text-decoration: initial;
			margin-top: 10rpx;
			margin-right: 20rpx;
		}

		button.btn_add {
			width: 49.5%;
			margin-top: 50rpx;
			padding: 20rpx;
			line-height: 1.5;
			background: #27A6E1;
			border: none;
			color: #fff;
			font-size: 38rpx;
			font-weight: bold;
			float: right;
			display: inline-block;
		}

		button.btn_cancel {
			width: 49.5%;
			margin-top: 50rpx;
			padding: 20rpx;
			line-height: 1.5;
			// background: #27A6E1;
			// border: none;
			// color: #fff;
			background: #fff;
			color: #000;
			font-size: 38rpx;
			font-weight: bold;
			float: left;
			display: inline-block;
		}

		button.btn_sava {
			width: 100%;
			margin-top: 50rpx;
			padding: 20rpx;
			line-height: 1.5;
			background: #27A6E1;
			border: none;
			color: #fff;
			font-size: 38rpx;
			font-weight: bold;
			float: left;
			display: inline-block;
		}

		button.btn_disabled {
			background-color: #ddd;
			color: #888;
		}

		.class_attr_body .form-group {
			margin: 20rpx 30rpx;
			/* margin-left: -12px;
    margin-right: -12px; */
		}

		.subclass_attr_body .form-group {
			margin: 20rpx 10rpx;
			/* margin-left: -12px;
    margin-right: -12px; */
		}

		.form-group>label[class*="col-"] {
			margin-bottom: 8rpx;
			font-size: 32rpx;
		}

		.form-group label {
			vertical-align: middle;
			line-height: 60rpx;
		}

		.tx_title2 {
			font-size: 32rpx;
			text-align: right;
			display: inline-block;
			vertical-align: -2px;
		}

		.attr_field {
			display: inline-block;
			vertical-align: middle;
			margin-left: 8px;
			/* width: 71%; */
		}

		.text-right2 {
			margin: 0;
			vertical-align: -4px;
			margin-left: 9px;
			float: none;
			font-size: 44rpx;
			display: inline-block;
		}

		input::-webkit-input-placeholder {
			font-size: 12rpx;
		}

		.v-panel input {
			border: 1px solid #d5d5d5;
			width: 98%;
			height: 52rpx;
			background: #FFF;
			border-radius: 0 !important;
			color: #046db3;
			padding: 10rpx 8rpx 12rpx;
			font-size: 34rpx;
			font-family: inherit;
			box-shadow: none !important;
			transition-duration: 0.1s;
			margin-top: 4rpx;
		}

		.date_iput {
			/* border: 1px solid #d5d5d5; */
			/* width: 98%; */
			height: 62rpx;
			background: #FFF;
			border-radius: 0 !important;
			color: #046db3;
			padding: 10rpx 8rpx 4rpx;
			font-size: 34rpx;
			font-family: inherit;
			box-shadow: none !important;
			transition-duration: 0.1s;
		}

		.dv_input {
			display: inline-block;
			width: 65%;
			/* line-height: 22rpx; */
		}

		.view-popup {
			position: relative;
		}

		.popup-content {
			// @include flex;
			align-items: center;
			justify-content: center;
			padding: 30rpx;
			background-color: #fff;
			/* height: 150px; */
			/* border: 1px solid red; */
		}

		.popup-cont {
			overflow-y: auto;
			/* border: 1px solid red; */
		}

		.popup-height {
			// @include height;
			/* width: 200px; */
		}

		.popup-header {
			font-size: 42rpx;
			font-weight: bold;
			margin: 20rpx 20rpx 0px 20rpx;
		}

		.view_popup_CheckList {
			margin-bottom: 20rpx;
		}

		.popup-footer {
			float: right;
			position: absolute;
			bottom: 10rpx;
			right: 20rpx;
		}

		button.btn_popup_add {
			width: 180rpx;
			margin-top: 50rpx;
			margin-right: 20rpx;
			padding: 15rpx;
			line-height: 1.5;
			background: #27A6E1;
			border: none;
			color: #fff;
			font-size: 38rpx;
			font-weight: bold;
			/* float: left; */
			display: inline-block;
		}

		button.btn_popup_cancel {
			width: 180rpx;
			margin-top: 50rpx;
			padding: 15rpx;
			line-height: 1.5;
			// background: #27A6E1;
			// border: none;
			// color: #fff;
			background: #fff;
			color: #000;
			font-size: 38rpx;
			font-weight: bold;
			/* float: right; */
			display: inline-block;
		}

		.bk-active {
			background-color: #D6FCB2;
			border: 1px solid #D6FCB2;
		}

		.view-floor {
			padding: 0 20rpx;
		}

		.demo-uni-row {
			margin-bottom: 0px;
			display: block;
		}

		::v-deep .uni-row {
			margin-bottom: 0px;
		}

		.view-tabpage ::v-deep .uni-row {
			margin-bottom: 5px;
		}

		.demo-uni-col {
			height: 36px;
			border-radius: 5px;
		}

		.demo-uni-row .uni-input {
			width: calc(100% - 120px);
		}

		.text {
			font-size: 12px;
			color: #666;
			margin-top: 5px;
		}

	}
</style>